import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.UIManager;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

/**
 * More extensive example with data model
 * 
 * @author fagg
 *
 */
public class MyFrame5 extends JFrame
{
    private JList<String> list;
    private DefaultListModel listModel;
    private JButton b1;
    private JButton b2;
    private JTextArea text;
    private Font font = new Font("Arial", Font.BOLD, 24);

    public MyFrame5(String title)
    {
        this.setSize(700, 400);

        this.setLocationRelativeTo(null);

        BorderLayout layout = new BorderLayout();
        this.setLayout(layout);

        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //////////// 
        // JList
        this.listModel = new DefaultListModel();
        String[] strgs = {"Foo", "Bar", "Baz"}; 
        for(String s: strgs)
        {
            this.listModel.addElement(s);
        }
        
        this.list = new JList<String>(listModel);
        this.list.setFont(this.font);
        
        this.add(list, BorderLayout.EAST);
        this.list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

        // Buttons
        b1 = new JButton("Button 1");
        b2 = new JButton("Button 2");
        b1.setFont(font);
        b2.setFont(font);
        
        this.add(b1, BorderLayout.NORTH);
        this.add(b2, BorderLayout.WEST);


        // Text
        text = new JTextArea("In Xanadu did Kubla Khan A stately pleasure-dome decree: ");
        text.setLineWrap(true);
        text.setWrapStyleWord(true);
        text.setFont(font);
        this.add(text, BorderLayout.CENTER);

        ///////////
        // Finish
        this.setVisible(true);

        this.list.addListSelectionListener(new ListSelectionListener() 
        {

            @Override
            public void valueChanged(ListSelectionEvent e)
            {
                String s = MyFrame5.this.list.getSelectedValue();
                MyFrame5.this.text.setText("SELECTED: " + s);

            }


        });
        
        this.b1.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent arg0)
            {
                int ret = JOptionPane.showConfirmDialog(MyFrame5.this , 
                        "Do you want green eggs and ham?",
                        "Sam, I am",
                        JOptionPane.YES_NO_CANCEL_OPTION,
                        JOptionPane.QUESTION_MESSAGE);
                
                MyFrame5.this.text.setText("Option: " + ret);
                
            }
            
        });
        
        this.b2.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e)
            {
                String s = "Element: " + MyFrame5.this.listModel.size();
                MyFrame5.this.listModel.addElement(s);
                
            }
            
        });

    }

    public static void main(String[] args) throws InterruptedException
    {
        MyFrame5 frame = new MyFrame5("My Frame");


    }

}
